﻿@page
@model BeamAndGo.Member.Admin.Web.Pages.Admin.AdminListModel
@{
    ViewData["Title"] = "Admin List";
}

<style>
    .uk-search-icon-flip svg {
        padding: 0 !important;
        cursor: pointer;
    }
</style>

<body>
    <div class="uk-container uk-container-center">
        <div class="uk-grid-small" uk-grid>
            <div class="uk-width-1-6@m uk-visible@m">
                @{
                    await Html.RenderPartialAsync("_Menu");
                }
            </div>

            <div class="uk-width-expand@m">
                <div class="uk-card uk-card-default uk-card-body">
                    <h3 class="uk-card-title">@ViewData["Title"]</h3>

                    <div uk-filter="target: .filter" class="uk-width-1-1 filter-main">
                        <table class="uk-table">
                            <tbody>
                                <tr>
                                    <td class="uk-text">
                                        <div class="uk-margin-small filter-options-container">
                                            <div class="filter-search-container">
                                                <form method="get" asp-page-handler="search" class="uk-subnav uk-subnav-pill uk-search uk-search-default uk-width-1-1">
                                                    <span class="uk-search-icon-flip" uk-search-icon></span>
                                                    <input name="search" asp-for="@Model.CurrentSearch" uk-filter-control="" class="uk-search-input" type="search" placeholder="Search by Name, Mobile Phone or Email">
                                                </form>
                                            </div>
                                        </div>
                                    </td>
                                    <td class="uk-text-nowrap uk-align-right">
                                        <a class="bng-modal uk-button uk-button-primary" asp-page="./CreateAdmin"> Add Admin</a>
                                    </td>
                                </tr>
                            </tbody>
                        </table>

                        @if (Model.PagesCount > 1)
                        {
                            <ul class="uk-pagination uk-flex-center" uk-margin>
                                @if (Model.CurrentPage > 1)
                                {
                                    <li><a asp-page="/Admin/List" asp-route-search="@Model.CurrentSearch" asp-route-start="@(Model.CurrentPage - 1)" class="page-link"> <i class="fas fa-chevron-left"> </i>  </a></li>
                                }

                                @if (Model.CurrentPage >= 2)
                                {
                                    @if (Model.CurrentPage >= 11)
                                    {
                                        <li><a asp-page="/Admin/List" asp-route-search="@Model.CurrentSearch" asp-route-start="@(Model.CurrentPage - 10)" class="page-link"> @(Model.CurrentPage - 10)</a></li>
                                    }
                                    else
                                    {
                                        <li><a asp-page="/Admin/List" asp-route-search="@Model.CurrentSearch" asp-route-start="1" class="page-link"> 1 </a></li>
                                    }

                                    <li class="uk-disabled"><span>...</span></li>
                                }

                                @for (var i = Model.CurrentPage; i < Model.CurrentPage + 11; i++)
                                {
                                    @if (Model.PagesCount >= i)
                                    {
                                        <li class="page-item @(i == Model.CurrentPage ? "uk-active uk-text-bold" : "")">
                                            <a asp-page="/Admin/List" asp-route-search="@Model.CurrentSearch" asp-route-start="@i" class="page-link">@i</a>
                                        </li>
                                    }
                                }

                                @if (Model.PagesCount > (Model.CurrentPage + 9))
                                {
                                    <li class="uk-disabled"><span>...</span></li>

                                    @if (Model.PagesCount > (Model.CurrentPage + 20))
                                    {
                                        <li><a asp-page="/Admin/List" asp-route-search="@Model.CurrentSearch" asp-route-start="@(Model.CurrentPage + 20)" class="page-link"> @(Model.CurrentPage + 20)</a></li>
                                    }
                                    else
                                    {
                                        <li><a asp-page="/Admin/List" asp-route-search="@Model.CurrentSearch" asp-route-start="@(Model.PagesCount)" class="page-link"> @(Model.PagesCount)</a></li>
                                    }
                                }

                                @if (Model.PagesCount > Model.CurrentPage)
                                {
                                    <li><a asp-page="/Admin/List" asp-route-search="@Model.CurrentSearch" asp-route-start="@(Model.CurrentPage + 1)" class="page-link"> <i class="fas fa-chevron-right"> </i> </a></li>
                                }

                            </ul>
                        }

                        <div class="uk-overflow-auto">
                            <table class="uk-table uk-table-hover uk-table-middle uk-table-divider">
                                <thead>
                                    <tr>
                                        <th class="uk-text-nowrap">First Name</th>
                                        <th class="uk-text-nowrap">Last Name</th>
                                        <th class="uk-text-nowrap">Access Level</th>
                                        <th class="uk-text-nowrap">Action</th>
                                    </tr>
                                </thead>
                                <tbody id="table-body">
                                    @foreach (var m in Model.MemberAdmins)
                                    {
                                        <tr>
                                            <td class="uk-text-nowrap">@m.Member.FirstName</td>
                                            <td class="uk-text-nowrap">@m.Member.LastName</td>
                                            <td class="uk-text-nowrap">@m.AccessLevel</td>
                                            <td class="uk-text-nowrap">
                                                <button class="member-admin-edit uk-button"
                                                        uk-toggle="target: #modal-admin-edit"
                                                        SelectedAdminID="@m.Sid"
                                                        SelectedMemberAdminName="@m.Member.FirstName @m.Member.LastName"
                                                        SelectedAccessLevel="@Convert.ToInt32(m.AccessLevel).ToString()"
                                                        SelectedExpiryDate="@(m.Expiry != null ? m.Expiry.Value.ToString("yyyy-MM-dd") : null)"
                                                        SelectedAccessStatus="@m.RecordStatus">
                                                    <i class="fas fa-pencil-alt"></i>
                                                </button>
                                            </td>
                                            <td class="uk-text-nowrap">
                                                <button class="member-admin-remove uk-button"
                                                        uk-toggle="target: #modal-admin-remove"
                                                        SelectedAdminID="@m.Sid"
                                                        SelectedMemberAdminName="@m.Member.FirstName @m.Member.LastName">
                                                    <i class="fas fa-trash"></i>
                                                </button>
                                            </td>
                                        </tr>
                                    }
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>


<!-- This is the modal -->
<div id="modal-admin-edit" uk-modal class="uk-flex-top modal-admin-edit">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body">
            <div class="uk-card uk-card-default uk-card-small uk-card-body">
                <form method="post" asp-page-handler="UpdateAdmin" asp-antiforgery="true">
                    <div class="uk-margin-small uk-margin-medium-bottom uk-grid-small" uk-grid>
                        <div class="uk-width-1-3 uk-text-center">
                            <div class="uk-margin-small">
                                <span class="uk-icon" uk-icon="icon: user; ratio: 5.0"></span>
                            </div>
                            <div class="uk-margin-small">
                                <input class="admin-member-sid" asp-for="AdminMemberSid" type="hidden">
                                <label class="admin-member-name uk-text-medium" />
                            </div>
                        </div>
                        <div class="uk-width-2-3">
                            <div class="uk-margin-small">
                                <label class="uk-form-label">Access Level</label>
                                <div>
                                    <select class="uk-select uk-width-1-1" id="accessLevel" asp-for="AccessLevel" asp-items="Html.GetEnumSelectList<MemberAdminAccessLevel>()">
                                    </select>
                                </div>
                            </div>
                            <div class="uk-margin-small">
                                <input class="admin-current-expiryDate" type="hidden">
                                <input class="set-expiryDate uk-checkbox" type="checkbox" checked="checked" onchange="valueChanged()">
                                <label class="uk-form-label">Expiration Date</label>
                            </div>
                            <div class="uk-margin-small">
                                <input asp-for="@Model.ExpiryDate" class="uk-input ExpirydatePicker" id="ExpirydatePicker" type="date" min="@Model.MinExpiryDate" placeholder="YYYY-MM-DD" />
                            </div>
                            <div class="uk-margin-small">
                                <label class="uk-form-label">Record Status</label>
                                <div>
                                    @foreach (var accessStatus in System.Enum.GetValues(typeof(BeamAndGo.Core.Data.RecordStatus)).OfType<BeamAndGo.Core.Data.RecordStatus>())
                                    {
                                        <label><input class="uk-radio" id="Record_@accessStatus" type="radio" asp-for="AdminRecordStatus" value="@accessStatus" /><span style="padding-right: 5px;"></span>@accessStatus<span style="padding-right: 10px;"></span></label>
                                    }
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-primary uk-width-1-1" type="submit">Update</button>
                    </div>
                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-default uk-width-1-1 uk-modal-close" type="button">Cancel</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal -->
<div id="modal-admin-remove" uk-modal class="uk-flex-top modal-admin-remove">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body uk-text-center">
            <p> Are you sure you want to remove <i><span class="remove-admin">beamandgo</span></i>?</p>
            <form method="post" asp-page-handler="removeAdmin" asp-antiforgery="true">
                <input type="hidden" asp-for="@Model.AdminMemberSid" id="remove-admin-selected" class="member-admin-remove-input" />
                <button class="uk-button uk-button-primary" type="submit">Ok</button>
                <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
            </form>
        </div>
    </div>
</div>
<!-- End of modal -->
<script>
    $(document).ready(function () {
    });

    $('.member-admin-edit').click(function () {
        $('.admin-member-sid').val($(this).attr('SelectedAdminID'));
        $('.admin-member-name').text($(this).attr('SelectedMemberAdminName'));
        $('#accessLevel').val($(this).attr('SelectedAccessLevel')).change();
        $("#Record_" + $(this).attr('SelectedAccessStatus')).attr("checked", "checked");


        if ($(this).attr('SelectedExpiryDate')) {
            $('.ExpirydatePicker').val($(this).attr('SelectedExpiryDate'));
            $('.admin-current-expiryDate').val($(this).attr('SelectedExpiryDate'));

            $(".set-expiryDate").prop("checked", true);
            $("#ExpirydatePicker").show();
        } else {
            $('.ExpirydatePicker').val('');
            $('.admin-current-expiryDate').val('');

            $(".set-expiryDate").prop("checked", false);
            $("#ExpirydatePicker").hide();
        }
    });

    $('.member-admin-remove').click(function () {
        $('.remove-admin').text($(this).attr('SelectedMemberAdminName'));
        $('.member-admin-remove-input').val($(this).attr('SelectedAdminID'));
    });

    function valueChanged() {
        if ($('.set-expiryDate').is(":checked")) {
            $("#ExpirydatePicker").show();
            $('.ExpirydatePicker').val($(".admin-current-expiryDate").val());
        }
        else {
            $("#ExpirydatePicker").hide();
            $('.ExpirydatePicker').val('');
        }
    }
</script>